/***************************************************************************
 *   Copyright (C) 2008 by Justin L. Boss                                  *
 *   justin@rtechguys.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KOCEANSETTING_H
#define KOCEANSETTING_H

//#include <QString>

class Settings {
    public:
        Settings();
        void load();
        void defaults();
        void save();

        // Graphics
        bool SampleBuffer;
        int Ambient;
        int CausticsFloor;
        int CausticsWave ;
        int Clarity;
        int Light;
        QColor Color;

        int Orca_Count;
        int Orca_Small;
        int Orca_Larg;
        int Orca_Speed;
        int Orca_Pattern;
        int Orca_Agility;
        int Orca_Far;
        int Orca_Near;
        int Orca_Depth;
        int Orca_TSpeed;
        int Orca_TMove;

        int LS_Count;
        int LS_Small;
        int LS_Larg;
        int LS_Speed;
        int LS_Pattern;
        int LS_Agility;
        int LS_Far;
        int LS_Near;
        int LS_Depth;
        int LS_TSpeed;
        int LS_TMove;

        int GW_Count;
        int GW_Small;
        int GW_Larg;
        int GW_Speed;
        int GW_Pattern;
        int GW_Agility;
        int GW_Far;
        int GW_Near;
        int GW_Depth;
        int GW_TSpeed;
        int GW_TMove;

        int BC_Count;
        int BC_Small;
        int BC_Larg;
        int BC_Speed;
        int BC_Pattern;
        int BC_Agility;
        int BC_Far;
        int BC_Near;
        int BC_Depth;
        int BC_TSpeed;
        int BC_TMove;

        int Sail_Count;
        int Sail_Small;
        int Sail_Larg;
        int Sail_Speed;
        int Sail_Pattern;
        int Sail_Agility;
        int Sail_Far;
        int Sail_Near;
        int Sail_Depth;
        int Sail_TSpeed;
        int Sail_TMove;

        int Spade_Count;
        int Spade_Small;
        int Spade_Larg;
        int Spade_Speed;
        int Spade_Pattern;
        int Spade_Agility;
        int Spade_Far;
        int Spade_Near;
        int Spade_Depth;
        int Spade_TSpeed;
        int Spade_TMove;

        int Tripletail_Count;
        int Tripletail_Small;
        int Tripletail_Larg;
        int Tripletail_Speed;
        int Tripletail_Pattern;
        int Tripletail_Agility;
        int Tripletail_Far;
        int Tripletail_Near;
        int Tripletail_Depth;
        int Tripletail_TSpeed;
        int Tripletail_TMove;

        bool WaveEnabled;
        int WaveWidth;
        int WaveDepth;
        int WaveSpeed;
        int WaveSize;

        bool RockEnabled;
        bool ShipEnabled;
        bool MausoleumEnabled;
        bool SeaFloorEnabled;

      bool RockingEnabled;
      float Amplitude;
      float Frequency;
};

//extern Settings* settings;

#endif // KOCEANSETTING_H
